Index: lib/TWiki/Render.pm
===================================================================
--- lib/TWiki/Render.pm	(revision 1767)
+++ lib/TWiki/Render.pm	(working copy)
@@ -36,30 +36,24 @@
 
 use strict;
 
-use TWiki qw(:renderflags %regex $TranslationToken);
+use TWiki;
+use TWiki::Attach;
 
-# ===========================
-# Read the configuration file at compile time in order to set locale
 BEGIN {
-    do "TWiki.cfg";
-
     # Do a dynamic 'use locale' for this module
     if( $TWiki::useLocale ) {
-        require locale;
-        import locale ();
+        eval 'require locale; import locale ();';
     }
 }
 
 # Globals used in rendering
 use vars qw(
-	$isList @listTypes @listElements
-        $newTopicFontColor $newTopicBgColor $linkToolTipInfo $noAutoLink
-        $newLinkSymbol %ffCache
-        
-    );
-    
+            $newTopicFontColor $newTopicBgColor $linkToolTipInfo $noAutoLink
+            $newLinkSymbol %ffCache $renderMode
+           );
 
 $noAutoLink = 0;
+$renderMode = 'html';		# Default is to render as HTML
 
 =pod
 
@@ -85,46 +79,29 @@
     # Prevent autolink of WikiWords
     $noAutoLink        = TWiki::Prefs::getPreferencesValue("NOAUTOLINK") || 0;
 
-  undef %ffCache;
+    undef %ffCache;
 }
 
-=pod
-
----++ sub renderParent (  $web, $topic, $meta, $args  )
-
-Not yet documented.
-
-=cut
-
-sub renderParent
+sub _renderParent
 {
     my( $web, $topic, $meta, $args ) = @_;
-    
-    my $text = "";
+    my %ah;
 
-    my $dontRecurse = 0;
-    my $noWebHome = 0;
-    my $prefix = "";
-    my $suffix = "";
-    my $usesep = "";
-
     if( $args ) {
-       $dontRecurse = TWiki::extractNameValuePair( $args, "dontrecurse" );
-       $noWebHome =   TWiki::extractNameValuePair( $args, "nowebhome" );
-       $prefix =      TWiki::extractNameValuePair( $args, "prefix" );
-       $suffix =      TWiki::extractNameValuePair( $args, "suffix" );
-       $usesep =      TWiki::extractNameValuePair( $args, "separator" );
+        %ah = TWiki::extractParameters( $args );
     }
+    my $dontRecurse = $ah{dontrecurse} || 0;
+    my $noWebHome =   $ah{nowebhome} || 0;
+    my $prefix =      $ah{prefix} || "";
+    my $suffix =      $ah{suffix} || "";
+    my $usesep =      $ah{separator} || " &gt; ";
 
-    if( ! $usesep ) {
-       $usesep = " &gt; ";
-    }
-
-    my %visited = ();
+    my %visited;
     $visited{"$web.$topic"} = 1;
 
     my $sep = "";
     my $cWeb = $web;
+    my $text = "";
 
     while( 1 ) {
         my %parent = $meta->findOne( "TOPICPARENT" );
@@ -136,7 +113,7 @@
                $pWeb = $1;
                $pTopic = $2;
             }
-            if( $noWebHome && ( $pTopic eq $mainTopicname ) ) {
+            if( $noWebHome && ( $pTopic eq $TWiki::mainTopicname ) ) {
                last;  # exclude "WebHome"
             }
             $text = "[[$pWeb.$pTopic][$pTopic]]$sep$text";
@@ -144,14 +121,13 @@
             if( $dontRecurse || ! $name ) {
                last;
             } else {
-               my $dummy;
                if( $visited{"$pWeb.$pTopic"} ) {
                   last;
                } else {
                   $visited{"$pWeb.$pTopic"} = 1;
                }
                if( TWiki::Store::topicExists( $pWeb, $pTopic ) ) {
-                   ( $meta, $dummy ) = TWiki::Store::readTopMeta( $pWeb, $pTopic );
+                   $meta = TWiki::Store::getMinimalMeta( $pWeb, $pTopic );
                } else {
                    last;
                }
@@ -173,23 +149,12 @@
     return $text;
 }
 
-# ========================
-=pod
-
----++ sub renderMoved (  $web, $topic, $meta  )
-
-Not yet documented.
-
-=cut
-
-sub renderMoved
+sub _renderMoved
 {
     my( $web, $topic, $meta ) = @_;
-    
     my $text = "";
-    
     my %moved = $meta->findOne( "TOPICMOVED" );
-    
+
     if( %moved ) {
         my $from = $moved{"from"};
         $from =~ /(.*)\.(.*)/;
@@ -200,34 +165,24 @@
         my $toWeb = $1;
         my $toTopic = $2;
         my $by   = $moved{"by"};
-        $by = TWiki::userToWikiName( $by );
+        $by = TWiki::User::userToWikiName( $by );
         my $date = $moved{"date"};
         $date = TWiki::formatTime( $date, "", "gmtime" );
-        
+
         # Only allow put back if current web and topic match stored information
         my $putBack = "";
         if( $web eq $toWeb && $topic eq $toTopic ) {
             $putBack  = " - <a title=\"Click to move topic back to previous location, with option to change references.\"";
-            $putBack .= " href=\"$dispScriptUrlPath/rename$scriptSuffix/$web/$topic?newweb=$fromWeb&newtopic=$fromTopic&";
+            $putBack .= " href=\"$TWiki::dispScriptUrlPath/rename$TWiki::scriptSuffix/$web/$topic?newweb=$fromWeb&newtopic=$fromTopic&";
             $putBack .= "confirm=on\">put it back</a>";
         }
         $text = "<i><nop>$to moved from <nop>$from on $date by $by </i>$putBack";
     }
-    
     return $text;
 }
 
 
-# ========================
-=pod
-
----++ sub renderFormField (  $meta, $args  )
-
-Not yet documented.
-
-=cut
-
-sub renderFormField
+sub _renderFormField
 {
     my( $meta, $args ) = @_;
     my $text = "";
@@ -238,22 +193,12 @@
     return $text;
 }
 
-# =========================
-=pod
-
----++ sub renderFormData (  $web, $topic, $meta  )
-
-Not yet documented.
-
-=cut
-
-sub renderFormData
+sub _renderFormData
 {
     my( $web, $topic, $meta ) = @_;
-
     my $metaText = "";
-    
     my %form = $meta->findOne( "FORM" );
+
     if( %form ) {
         my $name = $form{"name"};
         $metaText = "<div class=\"twikiForm\">\n";
@@ -278,10 +223,12 @@
 
 ---++ sub encodeSpecialChars (  $text  )
 
-Not yet documented.
+Escape out the chars &, ", >, < and whitespace with replaceable tokens.
+Presumably this is used to avoid browser interpretation
 
 =cut
 
+# "
 sub encodeSpecialChars
 {
     my( $text ) = @_;
@@ -300,14 +247,14 @@
 
 ---++ sub decodeSpecialChars (  $text  )
 
-Not yet documented.
+Reverse the encoding of encodeSpecialChars
 
 =cut
 
 sub decodeSpecialChars
 {
     my( $text ) = @_;
-    
+
     $text =~ s/%_N_%/\r\n/g;
     $text =~ s/%_L_%/</g;
     $text =~ s/%_G_%/>/g;
@@ -318,75 +265,57 @@
 }
 
 
-# =========================
 # Render bulleted and numbered lists, including nesting.
 # Called from several places.  Accumulates @listTypes and @listElements
 # to track nested lists.
-=pod
+sub _emitList {
+    my( $listTypes, $listElements, $result,
+        $theType, $theElement, $theIndent, $theOlType,
+       ) = @_;
 
----++ sub emitList (  $theType, $theElement, $theDepth, $theOlType  )
+    $theIndent =~ s/   /\t/g;
+    my $depth = length( $theIndent );
 
-Not yet documented.
-
-=cut
-
-sub emitList {
-    my( $theType, $theElement, $theDepth, $theOlType ) = @_;
-
-    my $result = "";
-    $isList = 1;
-
     # Ordered list type
     $theOlType = "" unless( $theOlType );
     $theOlType =~ s/^(.).*/$1/;
     $theOlType = "" if( $theOlType eq "1" );
 
-    if( @listTypes < $theDepth ) {
+    if( @$listTypes < $depth ) {
         my $firstTime = 1;
-        while( @listTypes < $theDepth ) {
-            push( @listTypes, $theType );
-            push( @listElements, $theElement );
-            $result .= "<$theElement>\n" unless( $firstTime );
+        while( @$listTypes < $depth ) {
+            push( @$listTypes, $theType );
+            push( @$listElements, $theElement );
+            push( @$result, "<$theElement>\n" ) unless( $firstTime );
             if( $theOlType ) {
-                $result .= "<$theType type=\"$theOlType\">\n";
+                push( @$result, "<$theType type=\"$theOlType\">\n" );
             } else {
-                $result .= "<$theType>\n";
+                push( @$result, "<$theType>\n" );
             }
             $firstTime = 0;
         }
 
-    } elsif( @listTypes > $theDepth ) {
-        while( @listTypes > $theDepth ) {
-            local($_) = pop @listElements;
-            $result .= "</$_>\n";
-            local($_) = pop @listTypes;
-            $result .= "</$_>\n";
+    } elsif( @$listTypes > $depth ) {
+        while( @$listTypes > $depth ) {
+            local($_) = pop @$listElements;
+            push( @$result, "</$_>\n" );
+            local($_) = pop @$listTypes;
+            push( @$result, "</$_>\n" );
         }
-        $result .= "</$listElements[$#listElements]>\n" if( @listElements );
+        push( @$result, "</$listElements->[$#$listElements]>\n") if( @$listElements );
 
-    } elsif( @listElements ) {
-        $result = "</$listElements[$#listElements]>\n";
+    } elsif( @$listElements ) {
+        push ( @$result, "</$listElements->[$#$listElements]>\n" );
     }
 
-    if( ( @listTypes ) && ( $listTypes[$#listTypes] ne $theType ) ) {
-        $result .= "</$listTypes[$#listTypes]>\n<$theType>\n";
-        $listTypes[$#listTypes] = $theType;
-        $listElements[$#listElements] = $theElement;
+    if( ( @$listTypes ) && ( $listTypes->[$#$listTypes] ne $theType ) ) {
+        push( @$result, "</$listTypes->[$#$listTypes]><$theType>\n" );
+        $listTypes->[$#$listTypes] = $theType;
+        $listElements->[$#$listElements] = $theElement;
     }
-
-    return $result;
 }
 
-# ========================
-=pod
-
----++ sub emitTR (  $thePre, $theRow, $insideTABLE  )
-
-Not yet documented.
-
-=cut
-
-sub emitTR {
+sub _emitTR {
     my ( $thePre, $theRow, $insideTABLE ) = @_;
 
     my $text = "";
@@ -400,12 +329,12 @@
     }
     $theRow =~ s/\t/   /g;  # change tabs to space
     $theRow =~ s/\s*$//;    # remove trailing spaces
-    $theRow =~ s/(\|\|+)/$TranslationToken . length($1) . "\|"/ge;  # calc COLSPAN
+    $theRow =~ s/(\|\|+)/$TWiki::TranslationToken . length($1) . "\|"/ge;  # calc COLSPAN
 
     foreach( split( /\|/, $theRow ) ) {
         $attr = "";
         #AS 25-5-01 Fix to avoid matching also single columns
-        if ( s/$TranslationToken([0-9]+)//o ) { 
+        if ( s/$TWiki::TranslationToken([0-9]+)//o ) { 
             $attr = " colspan=\"$1\"" ;
         }
         s/^\s+$/ &nbsp; /;
@@ -429,16 +358,7 @@
     return $text;
 }
 
-# =========================
-=pod
-
----++ sub fixedFontText (  $theText, $theDoBold  )
-
-Not yet documented.
-
-=cut
-
-sub fixedFontText
+sub _fixedFontText
 {
     my( $theText, $theDoBold ) = @_;
     # preserve white space, so replace it by "&nbsp; " patterns
@@ -451,28 +371,20 @@
     }
 }
 
-# =========================
 # Build an HTML &lt;Hn> element with suitable anchor for linking from %<nop>TOC%
-=pod
-
----++ sub makeAnchorHeading (  $theText, $theLevel  )
-
-Not yet documented.
-
-=cut
-
-sub makeAnchorHeading
+sub _makeAnchorHeading
 {
     my( $theHeading, $theLevel ) = @_;
 
     # - Build '<nop><h1><a name="atext"></a> heading </h1>' markup
     # - Initial '<nop>' is needed to prevent subsequent matches.
-    # - filter out $regex{headerPatternNoTOC} ( '!!' and '%NOTOC%' )
+    # - filter out $TWiki::regex{headerPatternNoTOC} ( '!!' and '%NOTOC%' )
     # CODE_SMELL: Empty anchor tags seem not to be allowed, but validators and browsers tolerate them
 
     my $anchorName =       makeAnchorName( $theHeading, 0 );
     my $compatAnchorName = makeAnchorName( $theHeading, 1 );
-    $theHeading =~ s/$regex{headerPatternNoTOC}//o; # filter '!!', '%NOTOC%'
+    # filter '!!', '%NOTOC%'
+    $theHeading =~ s/$TWiki::regex{headerPatternNoTOC}//o;
     my $text = "<nop><h$theLevel>";
     $text .= "<a name=\"$anchorName\"> </a>";
     $text .= "<a name=\"$compatAnchorName\"> </a>" if( $compatAnchorName ne $anchorName );
@@ -481,13 +393,13 @@
     return $text;
 }
 
-# =========================
-# Build a valid HTML anchor name
 =pod
 
----++ sub makeAnchorName (  $anchorName, $compatibilityMode  )
+---++ sub makeAnchorName($anchorName, $compatibilityMode)
+| =$anchorName= | |
+| =$compatibilityMode= | |
 
-Not yet documented.
+Build a valid HTML anchor name
 
 =cut
 
@@ -495,7 +407,7 @@
 {
     my( $anchorName, $compatibilityMode ) = @_;
 
-    if ( ! $compatibilityMode && $anchorName =~ /^$regex{anchorRegex}$/ ) {
+    if ( ! $compatibilityMode && $anchorName =~ /^$TWiki::regex{anchorRegex}$/ ) {
 	# accept, already valid -- just remove leading #
 	return substr($anchorName, 1);
     }
@@ -509,10 +421,10 @@
     $anchorName =~ s/<\w[^>]*>//gi;         # remove HTML tags
     $anchorName =~ s/\&\#?[a-zA-Z0-9]*;//g; # remove HTML entities
     $anchorName =~ s/\&//g;                 # remove &
-    $anchorName =~ s/^(.+?)\s*$regex{headerPatternNoTOC}.*/$1/o; # filter TOC excludes if not at beginning
-    $anchorName =~ s/$regex{headerPatternNoTOC}//o; # filter '!!', '%NOTOC%'
+    $anchorName =~ s/^(.+?)\s*$TWiki::regex{headerPatternNoTOC}.*/$1/o; # filter TOC excludes if not at beginning
+    $anchorName =~ s/$TWiki::regex{headerPatternNoTOC}//o; # filter '!!', '%NOTOC%'
     # FIXME: More efficient to match with '+' on next line:
-    $anchorName =~ s/$regex{singleMixedNonAlphaNumRegex}/_/g;      # only allowed chars
+    $anchorName =~ s/[^$TWiki::regex{mixedAlphaNum}]/_/g;      # only allowed chars
     $anchorName =~ s/__+/_/g;               # remove excessive '_'
     if ( !$compatibilityMode ) {
         $anchorName =~ s/^[\s\#\_]*//;      # no leading space nor '#', '_'
@@ -527,17 +439,9 @@
     return $anchorName;
 }
 
-# =========================
-=pod
-
----++ sub linkToolTipInfo ( $theWeb, $theTopic )
-
-Returns =title="..."= tooltip info in case LINKTOOLTIPINFO perferences variable is set. 
-Warning: Slower performance if enabled.
-
-=cut
-
-sub linkToolTipInfo
+# Returns =title="..."= tooltip info in case LINKTOOLTIPINFO perferences variable is set. 
+# Warning: Slower performance if enabled.
+sub _linkToolTipInfo
 {
     my( $theWeb, $theTopic ) = @_;
     return "" unless( $linkToolTipInfo );
@@ -551,31 +455,34 @@
     $text =~ s/\$rev/1.$rev/g;
     $text =~ s/\$date/&TWiki::formatTime( $date )/ge;
     $text =~ s/\$username/<nop>$user/g;                                     # "jsmith"
-    $text =~ s/\$wikiname/"<nop>" . &TWiki::userToWikiName( $user, 1 )/ge;  # "JohnSmith"
-    $text =~ s/\$wikiusername/"<nop>" . &TWiki::userToWikiName( $user )/ge; # "Main.JohnSmith"
+    $text =~ s/\$wikiname/"<nop>" . &TWiki::User::userToWikiName( $user, 1 )/ge;  # "JohnSmith"
+    $text =~ s/\$wikiusername/"<nop>" . &TWiki::User::userToWikiName( $user )/ge; # "Main.JohnSmith"
     if( $text =~ /\$summary/ ) {
         my $summary = &TWiki::Store::readFileHead( "$TWiki::dataDir/$theWeb/$theTopic.txt", 16 );
-        $summary = &TWiki::makeTopicSummary( $summary, $theTopic, $theWeb );
+        $summary = makeTopicSummary( $summary, $theTopic, $theWeb );
         $summary =~ s/[\"\']/<nop>/g;       # remove quotes (not allowed in title attribute)
         $text =~ s/\$summary/$summary/g;
     }
     return " title=\"$text\"";
 }
 
-# =========================
 =pod
 
----++ sub internalLink (  $thePreamble, $theWeb, $theTopic, $theLinkText, $theAnchor, $doLink, $doKeepWeb )
+---++ sub internalLink ( $theWeb, $theTopic, $theLinkText, $theAnchor, $doLink, $doKeepWeb )
 
-Not yet documented.
+Generate a link.
 
+| =$theWeb= | the web containing the topic |
+| =$theTopic= | the topic to be lunk |
+| =$theLinkText= | text to use for the link |
+| =$theAnchor= | the link anchor, if any |
+| =$doLink= | boolean: false means suppress link for non-existing pages |
+| =$doKeepWeb= | boolean: true to keep web prefix (for non existing Web.TOPIC) |
+
 =cut
 
 sub internalLink {
-    my( $thePreamble, $theWeb, $theTopic, $theLinkText, $theAnchor, $doLink, $doKeepWeb ) = @_;
-    # $thePreamble is text used before the TWiki link syntax
-    # $doLink is boolean: false means suppress link for non-existing pages
-    # $doKeepWeb is boolean: true to keep web prefix (for non existing Web.TOPIC)
+    my( $theWeb, $theTopic, $theLinkText, $theAnchor, $doLink, $doKeepWeb ) = @_;
 
     # Get rid of leading/trailing spaces in topic name
     $theTopic =~ s/^\s*//;
@@ -585,24 +492,25 @@
     # whole link, and first of each word. TODO: Try to turn this off,
     # avoiding spaces being stripped elsewhere - e.g. $doPreserveSpacedOutWords 
     $theTopic =~ s/^(.)/\U$1/;
-    $theTopic =~ s/\s($regex{singleMixedAlphaNumRegex})/\U$1/go;	
+    $theTopic =~ s/\s([$TWiki::regex{mixedAlphaNum}])/\U$1/go;	
 
     # Add <nop> before WikiWord inside link text to prevent double links
-    $theLinkText =~ s/([\s\(])($regex{singleUpperAlphaRegex})/$1<nop>$2/go;
+    $theLinkText =~ s/([\s\(])([$TWiki::regex{upperAlpha}])/$1<nop>$2/go;
  
      # Allow spacing out, etc
-     if (TWiki::isWikiName($theLinkText)) {
+     if (TWiki::isValidWikiWord($theLinkText)) {
         $theLinkText = TWiki::Plugins::renderWikiWordHandler( $theLinkText ) || $theLinkText;
      }
 
     my $exist = &TWiki::Store::topicExists( $theWeb, $theTopic );
+
     # I18N - Only apply plural processing if site language is English, or
     # if a built-in English-language web (Main, TWiki or Plugins).  Plurals
     # apply to names ending in 's', where topic doesn't exist with plural
     # name.
-    if(  ( $doPluralToSingular ) and ( $siteLang eq 'en' 
-					or $theWeb eq $mainWebname
-					or $theWeb eq $twikiWebname
+    if(  ( $TWiki::doPluralToSingular ) and ( $TWiki::siteLang eq 'en' 
+					or $theWeb eq $TWiki::mainWebname
+					or $theWeb eq $TWiki::twikiWebname
 					or $theWeb eq 'Plugins' 
 				     ) 
 	    and ( $theTopic =~ /s$/ ) and not ( $exist ) ) {
@@ -618,19 +526,19 @@
         }
     }
 
-    my $text = $thePreamble;
+    my $text = "";
     if( $exist) {
         if( $theAnchor ) {
             my $anchor = makeAnchorName( $theAnchor );
-            $text .= "<a class=\"twikiAnchorLink\" href=\"$dispScriptUrlPath$dispViewPath"
-		  .  "$scriptSuffix/$theWeb/$theTopic\#$anchor\""
-                  .  &linkToolTipInfo( $theWeb, $theTopic )
+            $text .= "<a class=\"twikiAnchorLink\" href=\"$TWiki::dispScriptUrlPath$TWiki::dispViewPath"
+		  .  "$TWiki::scriptSuffix/$theWeb/$theTopic\#$anchor\""
+                  .  &_linkToolTipInfo( $theWeb, $theTopic )
                   .  ">$theLinkText</a>";
             return $text;
         } else {
-            $text .= "<a class=\"twikiLink\" href=\"$dispScriptUrlPath$dispViewPath"
-		  .  "$scriptSuffix/$theWeb/$theTopic\""
-                  .  &linkToolTipInfo( $theWeb, $theTopic )
+            $text .= "<a class=\"twikiLink\" href=\"$TWiki::dispScriptUrlPath$TWiki::dispViewPath"
+		  .  "$TWiki::scriptSuffix/$theWeb/$theTopic\""
+                  .  &_linkToolTipInfo( $theWeb, $theTopic )
                   .  ">$theLinkText</a>";
             return $text;
         }
@@ -638,7 +546,7 @@
     } elsif( $doLink ) {
         $text .= "<span class=\"twikiNewLink\" style='background : $newTopicBgColor;'>"
               .  "<font color=\"$newTopicFontColor\">$theLinkText</font>"
-              .  "<a href=\"$dispScriptUrlPath/edit$scriptSuffix/$theWeb/$theTopic?topicparent=$TWiki::webName.$TWiki::topicName\">$newLinkSymbol</a></span>";
+              .  "<a href=\"$TWiki::dispScriptUrlPath/edit$TWiki::scriptSuffix/$theWeb/$theTopic?topicparent=$TWiki::webName.$TWiki::topicName\">$newLinkSymbol</a></span>";
         return $text;
 
     } elsif( $doKeepWeb ) {
@@ -651,93 +559,62 @@
     }
 }
 
-# =========================
-=pod
-
----++ sub internalCrosswebLink (  $thePreamble, $theWeb, $theTopic, $theLinkText, $theAnchor, $doLink  )
-
-Not yet documented.
-
-=cut
-
-sub internalCrosswebLink
+# Handle specific links of the form:
+# format: [[$theText]]
+# format: [[$theLink][$theText]]
+sub _specificLink
 {
-    my( $thePreamble, $theWeb, $theTopic, $theLinkText, $theAnchor, $doLink ) = @_;
-    if ( $theTopic eq $TWiki::mainTopicname && $theWeb ne $TWiki::webName ) {
-        return internalLink( $thePreamble, $theWeb, $theTopic, $theWeb, $theAnchor, $doLink );
-    } else {
-        return internalLink( $thePreamble, $theWeb, $theTopic, $theLinkText, $theAnchor, $doLink );
-    }
-}
+    my( $theWeb, $theTopic, $theText, $theLink ) = @_;
 
-# =========================
-# Handle most internal and external links
-=pod
+    $theText = $theLink unless defined( $theText );
 
----++ sub specificLink (  $thePreamble, $theWeb, $theTopic, $theText, $theLink  )
-
-Not yet documented.
-
-=cut
-
-sub specificLink
-{
-    my( $thePreamble, $theWeb, $theTopic, $theText, $theLink ) = @_;
-
-    # format: $thePreamble[[$theText]]
-    # format: $thePreamble[[$theLink][$theText]]
-    #
     # Current page's $theWeb and $theTopic are also used
 
     # Strip leading/trailing spaces
     $theLink =~ s/^\s*//;
     $theLink =~ s/\s*$//;
 
-    if( $theLink =~ /^$regex{linkProtocolPattern}\:/ ) {
+    if( $theLink =~ /^$TWiki::regex{linkProtocolPattern}\:/ ) {
+        if ( $theLink =~ /^(\S+)\s+(.*)$/ ) {
+            # '[[URL#anchor display text]]' link:
+            $theLink = $1;
+            $theText = $2;
+        } else {
+            # '[[Web.odd wiki word#anchor][display text]]' link:
+            # '[[Web.odd wiki word#anchor]]' link:
 
-        # External link: add <nop> before WikiWord and ABBREV 
-	# inside link text, to prevent double links
-	$theText =~ s/([\s\(])($regex{singleUpperAlphaRegex})/$1<nop>$2/go;
-        return "$thePreamble<a href=\"$theLink\" target=\"_top\">$theText</a>";
+            # External link: add <nop> before WikiWord and ABBREV 
+            # inside link text, to prevent double links
+            $theText =~ s/([\s\(])([$TWiki::regex{upperAlpha}])/$1<nop>$2/go;
+        }
+        return "<a href=\"$theLink\" target=\"_top\">$theText</a>";
+    }
 
-    } else {
+    # Internal link: get any 'Web.' prefix, or use current web
+    $theLink =~ s/^($TWiki::regex{webNameRegex}|$TWiki::regex{defaultWebNameRegex})\.//;
+    my $web = $1 || $theWeb;
+    (my $baz = "foo") =~ s/foo//;       # reset $1, defensive coding
 
-	# Internal link: get any 'Web.' prefix, or use current web
-	$theLink =~ s/^($regex{webNameRegex}|$regex{defaultWebNameRegex})\.//;
-	my $web = $1 || $theWeb;
-	(my $baz = "foo") =~ s/foo//;       # reset $1, defensive coding
+    # Extract '#anchor'
+    # FIXME and NOTE: Had '-' as valid anchor character, removed
+    # $theLink =~ s/(\#[a-zA-Z_0-9\-]*$)//;
+    $theLink =~ s/($TWiki::regex{anchorRegex}$)//;
+    my $anchor = $1 || "";
 
-	# Extract '#anchor'
-	# FIXME and NOTE: Had '-' as valid anchor character, removed
-	# $theLink =~ s/(\#[a-zA-Z_0-9\-]*$)//;
-	$theLink =~ s/($regex{anchorRegex}$)//;
-	my $anchor = $1 || "";
-
-	# Get the topic name
-	my $topic = $theLink || $theTopic;  # remaining is topic
-	$topic =~ s/\&[a-z]+\;//gi;        # filter out &any; entities
-	$topic =~ s/\&\#[0-9]+\;//g;       # filter out &#123; entities
-	$topic =~ s/[\\\/\#\&\(\)\{\}\[\]\<\>\!\=\:\,\.]//g;
-	$topic =~ s/$securityFilter//go;    # filter out suspicious chars
-	if( ! $topic ) {
-	    return "$thePreamble$theText"; # no link if no topic
-	}
-
-	return internalLink( $thePreamble, $web, $topic, $theText, $anchor, 1 );
+    # Get the topic name
+    my $topic = $theLink || $theTopic;  # remaining is topic
+    $topic =~ s/\&[a-z]+\;//gi;        # filter out &any; entities
+    $topic =~ s/\&\#[0-9]+\;//g;       # filter out &#123; entities
+    $topic =~ s/[\\\/\#\&\(\)\{\}\[\]\<\>\!\=\:\,\.]//g;
+    $topic =~ s/$TWiki::securityFilter//go;    # filter out suspicious chars
+    if( ! $topic ) {
+        return $theText; # no link if no topic
     }
 
+    return internalLink( $web, $topic, $theText, $anchor, 1 );
 }
 
-# =========================
-=pod
-
----++ sub externalLink (  $pre, $url  )
-
-Not yet documented.
-
-=cut
-
-sub externalLink
+sub _externalLink
 {
     my( $pre, $url ) = @_;
     if( $url =~ /\.(gif|jpg|jpeg|png)$/i ) {
@@ -749,16 +626,7 @@
     return "$pre<a href=\"$url\" target=\"_top\">$url</a>";
 }
 
-# =========================
-=pod
-
----++ sub mailtoLink (  $theAccount, $theSubDomain, $theTopDomain  )
-
-Not yet documented.
-
-=cut
-
-sub mailtoLink
+sub _mailtoLink
 {
     my( $theAccount, $theSubDomain, $theTopDomain ) = @_;
 
@@ -766,16 +634,7 @@
     return "<a href=\"mailto\:$addr\">$addr</a>";
 }
 
-# =========================
-=pod
-
----++ sub mailtoLinkFull (  $theAccount, $theSubDomain, $theTopDomain, $theLinkText  )
-
-Not yet documented.
-
-=cut
-
-sub mailtoLinkFull
+sub _mailtoLinkFull
 {
     my( $theAccount, $theSubDomain, $theTopDomain, $theLinkText ) = @_;
 
@@ -783,16 +642,7 @@
     return "<a href=\"mailto\:$addr\">$theLinkText</a>";
 }
 
-# =========================
-=pod
-
----++ sub mailtoLinkSimple (  $theMailtoString, $theLinkText  )
-
-Not yet documented.
-
-=cut
-
-sub mailtoLinkSimple
+sub _mailtoLinkSimple
 {
     # Does not do any anti-spam padding, because address will not include '@'
     my( $theMailtoString, $theLinkText ) = @_;	
@@ -806,86 +656,122 @@
 
 =pod
 
----++ sub getFormField ( $web, $topic, $args )
+---++ sub filenameToIcon (  $fileName  )
 
-+Returns the expansion of a %FORMFIELD{}% tag.
+Produce an image tailored to the type of the file, guessed from
+its extension.
 
+used in TWiki::handleIcon
+
 =cut
 
-sub getFormField
+sub filenameToIcon
 {
-   my( $web, $topic, $args ) = @_;
+    my( $fileName ) = @_;
 
-  my $formField = TWiki::extractNameValuePair( $args );
-  my $formTopic = TWiki::extractNameValuePair( $args, "topic" );
-  my $altText   = TWiki::extractNameValuePair( $args, "alttext" );
-  my $default   = TWiki::extractNameValuePair( $args, "default" ) || undef;
-  my $format    = TWiki::extractNameValuePair( $args, "format" );
+    my @bits = ( split( /\./, $fileName ) );
+    my $fileExt = lc $bits[$#bits];
 
-  unless ( $format ) {
-       # if null format explicitly set, return empty
-       return "" if ( $args =~ m/format\s*=/o);
-       # Otherwise default to value
-       $format = "\$value";
-  }
+    my $iconDir = "$TWiki::pubDir/icn";
+    my $iconUrl = "$TWiki::pubUrlPath/icn";
+    my $iconList = &TWiki::Store::readFile( "$iconDir/_filetypes.txt" );
+    foreach( split( /\n/, $iconList ) ) {
+        @bits = ( split( / / ) );
+	if( $bits[0] eq $fileExt ) {
+            return "<img src=\"$iconUrl/$bits[1].gif\" width=\"16\" height=\"16\" align=\"top\" alt=\"\" border=\"0\" />";
+        }
+    }
+    return "<img src=\"$iconUrl/else.gif\" width=\"16\" height=\"16\" align=\"top\" alt=\"\" border=\"0\" />";
+}
 
-  my $formWeb;
-  if ( $formTopic ) {
-       if ($topic =~ /^([^.]+)\.([^.]+)/o) {
-         ( $formWeb, $topic ) = ( $1, $2 );
-	   } else {
-         # SMELL: Undocumented feature, "web" parameter
-         $formWeb = TWiki::extractNameValuePair( $args, "web" );
-	   }
-       $formWeb = $web unless $formWeb;
-  } else {
-       $formWeb = $web;
-       $formTopic = $topic;
-  }
+=pod
 
-  my $meta = $ffCache{"$formWeb.$formTopic"};
-  unless ( $meta ) {
-       my $dummyText;
-       ( $meta, $dummyText ) =
-         TWiki::Store::readTopic( $formWeb, $formTopic );
-       $ffCache{"$formWeb.$formTopic"} = $meta;
-  }
+---++ sub renderFormField ( %params, $topic, $web )
 
-  my $text = "";
-  my $found = 0;
-  if ( $meta ) {
-       my @fields = $meta->find( "FIELD" );
-       foreach my $field ( @fields ) {
-         my $title = $field->{"title"};
-         my $name = $field->{"name"};
-         if( $title eq $formField || $name eq $formField ) {
-               $found = 1;
-               my $value = $field->{"value"};
-               if (length $value) {
-                 $text = $format;
-                 $text =~ s/\$value/$value/go;
-               } elsif ( defined $default ) {
-                 $text = $default;
-               }
-               last; #one hit suffices
-         }
-       }
-  }
+Returns the fully rendered expansion of a %FORMFIELD{}% tag.
 
-  unless ( $found ) {
-       $text = $altText;
-  }
+=cut
 
-  return "" unless $text;
+sub renderFormField
+{
+    my %params = shift;
 
-  return getRenderedVersion( $text, $web );
+    my $topic = $params{_theTopic};
+    my $web = $params{_theWeb};
+
+    my $formField = $params{_DEFAULT};
+    my $formTopic = $params{ "topic" };
+    my $altText   = $params{ "alttext" };
+    my $default   = $params{ "default" };
+    my $format    = $params{ "format" };
+
+    unless ( $format ) {
+        # if null format explicitly set, return empty
+        # SMELL: it's not clear what this does; the implication
+        # is that it does something that violates TWiki tag syntax,
+        # so I've had to comment it out....
+        # return "" if ( $args =~ m/format\s*=/o);
+        # Otherwise default to value
+        $format = "\$value";
+    }
+
+    my $formWeb;
+    if ( $formTopic ) {
+        if ($topic =~ /^([^.]+)\.([^.]+)/o) {
+            ( $formWeb, $topic ) = ( $1, $2 );
+        } else {
+            # SMELL: Undocumented feature, "web" parameter
+            $formWeb = $params{"web"};
+        }
+        $formWeb = $web unless $formWeb;
+    } else {
+        $formWeb = $web;
+        $formTopic = $topic;
+    }
+
+    my $meta = $ffCache{"$formWeb.$formTopic"};
+    unless ( $meta ) {
+        my $dummyText;
+        ( $meta, $dummyText ) =
+          TWiki::Store::readTopic( $formWeb, $formTopic );
+        $ffCache{"$formWeb.$formTopic"} = $meta;
+    }
+
+    my $text = "";
+    my $found = 0;
+    if ( $meta ) {
+        my @fields = $meta->find( "FIELD" );
+        foreach my $field ( @fields ) {
+            my $title = $field->{"title"};
+            my $name = $field->{"name"};
+            if( $title eq $formField || $name eq $formField ) {
+                $found = 1;
+                my $value = $field->{"value"};
+                if (length $value) {
+                    $text = $format;
+                    $text =~ s/\$value/$value/go;
+                } elsif ( defined $default ) {
+                    $text = $default;
+                }
+                last; #one hit suffices
+            }
+        }
+    }
+
+    unless ( $found ) {
+        $text = $altText;
+    }
+
+    return "" unless $text;
+
+    return getRenderedVersion( $text, $web );
 }
 
 =pod
 
 ---++ sub getRenderedVersion (  $text, $theWeb, $meta  )
 
-Not yet documented.
+The main rendering function.
 
 =cut
 
@@ -900,7 +786,6 @@
     # (fails in %INCLUDE%, %SEARCH%)
     my $theTopic = $TWiki::topicName;
 
-    # PTh 22 Jul 2000: added $theWeb for correct handling of %INCLUDE%, %SEARCH%
     if( !$theWeb ) {
         $theWeb = $TWiki::webName;
     }
